diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
index 953c0934a..46a8f0494 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
@@ -83,24 +83,24 @@ public class BlockLogicFence extends BlockLogic implements IPaintable
 
     @Override
     public void getCollidingBoundingBoxes(World world, int x, int y, int z, AABB aabb, ArrayList<AABB> aabbList) {
-        boolean connectXPos = canConnectTo(world, x + 1, y, z);
-        boolean connectXNeg = canConnectTo(world, x - 1, y, z);
-        boolean connectZPos = canConnectTo(world, x, y, z + 1);
-        boolean connectZNeg = canConnectTo(world, x, y, z - 1);
+        boolean connectEast = canConnectTo(world, x, y, z, Side.EAST);
+        boolean connectWest = canConnectTo(world, x, y, z, Side.WEST);
+        boolean connectSouth = canConnectTo(world, x, y, z, Side.SOUTH);
+        boolean connectNorth = canConnectTo(world, x, y, z, Side.NORTH);
         final double thickness = 0.5 - 0.375;
-        if (connectXPos) {
+        if (connectEast) {
             addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - thickness, 0, 0.5 - thickness, 1, 1.5, 0.5 + thickness).move(x, y, z), aabbList);
         }
-        if (connectXNeg) {
+        if (connectWest) {
             addIntersectingBoundingBox(aabb, AABB.fromPool(0, 0, 0.5 - thickness, 0.5 + thickness, 1.5, 0.5 + thickness).move(x, y, z), aabbList);
         }
-        if (connectZPos) {
+        if (connectSouth) {
             addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - thickness, 0, 0.5 - thickness, 0.5 + thickness, 1.5, 1).move(x, y, z), aabbList);
         }
-        if (connectZNeg) {
+        if (connectNorth) {
             addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - thickness, 0, 0, 0.5 + thickness, 1.5, 0.5 + thickness).move(x, y, z), aabbList);
         }
-        if (!connectXPos && !connectXNeg && !connectZPos && !connectZNeg) {
+        if (!connectEast && !connectWest && !connectSouth && !connectNorth) {
             addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - thickness, 0, 0.5 - thickness, 0.5 + thickness, 1.5, 0.5 + thickness).move(x, y, z), aabbList);
         }
     }
@@ -126,10 +126,10 @@ public class BlockLogicFence extends BlockLogic implements IPaintable
     @Override
     public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
-        boolean connectXPos = canConnectTo(world, x + 1, y, z);
-        boolean connectXNeg = canConnectTo(world, x - 1, y, z);
-        boolean connectZPos = canConnectTo(world, x, y, z + 1);
-        boolean connectZNeg = canConnectTo(world, x, y, z - 1);
+        boolean connectXPos = canConnectTo(world, x, y, z, Side.EAST);
+        boolean connectXNeg = canConnectTo(world, x, y, z, Side.WEST);
+        boolean connectZPos = canConnectTo(world, x, y, z, Side.SOUTH);
+        boolean connectZNeg = canConnectTo(world, x, y, z, Side.NORTH);
         return AABB.fromPool((connectXNeg ? 0.0f : 0.375f), 0, (connectZNeg ? 0.0f : 0.375f), 1 - (connectXPos ? 0.0f : 0.375f), 1, 1 - (connectZPos ? 0.0f : 0.375f));
     }
 
@@ -145,10 +145,10 @@ public class BlockLogicFence extends BlockLogic implements IPaintable
         return false;
     }
 
-    public boolean canConnectTo(WorldSource worldSource, int x, int y, int z)
+    public boolean canConnectTo(@NotNull WorldSource worldSource, int x, int y, int z, @NotNull Side side)
     {
-        int l = worldSource.getBlockId(x, y, z);
-        return Blocks.hasTag(l, BlockTags.FENCES_CONNECT);
+        Block<?> b = worldSource.getBlock(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ());
+        return Blocks.hasTag(b, BlockTags.FENCES_CONNECT) || (b != null && b.getAttachedSide(worldSource, x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ()) == side.getOpposite());
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceChainlink.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceChainlink.java
index 49f58ab89..4f25ce74e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceChainlink.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceChainlink.java
@@ -2,8 +2,10 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicFenceChainlink extends BlockLogicFenceThin
 {
@@ -13,10 +15,10 @@ public class BlockLogicFenceChainlink extends BlockLogicFenceThin
     }
 
     @Override
-    public boolean canConnectTo(WorldSource world, int x, int y, int z)
+    public boolean canConnectTo(@NotNull WorldSource world, int x, int y, int z, @NotNull Side side)
     {
-        Block<?> b = world.getBlock(x, y, z);
-        return BlockTags.CHAINLINK_FENCES_CONNECT.appliesTo(b) || (b != null && (b.getMaterial().isStone() || b.getMaterial().isMetal()));
+        Block<?> b = world.getBlock(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ());
+        return Blocks.hasTag(b, BlockTags.CHAINLINK_FENCES_CONNECT) || (b != null && b.getAttachedSide(world, x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ()) == side.getOpposite());
     }
     
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceSteel.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceSteel.java
index 1b3f4f2fd..a501c8d98 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceSteel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceSteel.java
@@ -2,7 +2,9 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicFenceSteel extends BlockLogicFenceThin {
     public BlockLogicFenceSteel(Block<?> block, Material material) {
@@ -10,8 +12,8 @@ public class BlockLogicFenceSteel extends BlockLogicFenceThin {
     }
 
     @Override
-    public boolean canConnectTo(WorldSource world, int x, int y, int z) {
-        Block<?> block = world.getBlock(x, y, z);
-        return BlockTags.CHAINLINK_FENCES_CONNECT.appliesTo(block) || (block != null && (block.getMaterial().isStone() || block.getMaterial().isMetal()));
+    public boolean canConnectTo(@NotNull WorldSource world, int x, int y, int z, @NotNull Side side) {
+        Block<?> b = world.getBlock(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ());
+        return Blocks.hasTag(b, BlockTags.CHAINLINK_FENCES_CONNECT) || (b != null && b.getAttachedSide(world, x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ()) == side.getOpposite());
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java
index 3d8797bfb..b73b6b50e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java
@@ -3,13 +3,14 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
-import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.NotNull;
 
+import java.util.ArrayList;
+
 public abstract class BlockLogicFenceThin extends BlockLogic
 {
     public BlockLogicFenceThin(Block<?> block, Material material)
@@ -31,11 +32,35 @@ public abstract class BlockLogicFenceThin extends BlockLogic
     @Override
     public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
-        boolean connectXPos = canConnectTo(world, x + 1, y, z);
-        boolean connectXNeg = canConnectTo(world, x - 1, y, z);
-        boolean connectZPos = canConnectTo(world, x, y, z + 1);
-        boolean connectZNeg = canConnectTo(world, x, y, z - 1);
-        return AABB.fromPool((connectXNeg ? 0.0f : 0.375f), 0, (connectZNeg ? 0.0f : 0.375f), 1 - (connectXPos ? 0.0f : 0.375f), 1, 1 - (connectZPos ? 0.0f : 0.375f));
+        boolean connectEast = canConnectTo(world, x, y, z, Side.EAST);
+        boolean connectWest = canConnectTo(world, x, y, z, Side.WEST);
+        boolean connectSouth = canConnectTo(world, x, y, z, Side.SOUTH);
+        boolean connectNorth = canConnectTo(world, x, y, z, Side.NORTH);
+        return AABB.fromPool((connectWest ? 0.0f : 0.375f), 0, (connectNorth ? 0.0f : 0.375f), 1 - (connectEast ? 0.0f : 0.375f), 1, 1 - (connectSouth ? 0.0f : 0.375f));
+    }
+
+    @Override
+    public void getCollidingBoundingBoxes(World world, int x, int y, int z, AABB aabb, ArrayList<AABB> aabbList) {
+        boolean connectEast = canConnectTo(world, x, y, z, Side.EAST);
+        boolean connectWest = canConnectTo(world, x, y, z, Side.WEST);
+        boolean connectSouth = canConnectTo(world, x, y, z, Side.SOUTH);
+        boolean connectNorth = canConnectTo(world, x, y, z, Side.NORTH);
+        final double thickness = 0.5 - 0.375;
+        if (connectEast) {
+            addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - thickness, 0, 0.5 - thickness, 1, 1, 0.5 + thickness).move(x, y, z), aabbList);
+        }
+        if (connectWest) {
+            addIntersectingBoundingBox(aabb, AABB.fromPool(0, 0, 0.5 - thickness, 0.5 + thickness, 1, 0.5 + thickness).move(x, y, z), aabbList);
+        }
+        if (connectSouth) {
+            addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - thickness, 0, 0.5 - thickness, 0.5 + thickness, 1, 1).move(x, y, z), aabbList);
+        }
+        if (connectNorth) {
+            addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - thickness, 0, 0, 0.5 + thickness, 1, 0.5 + thickness).move(x, y, z), aabbList);
+        }
+        if (!connectEast && !connectWest && !connectSouth && !connectNorth) {
+            addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - thickness, 0, 0.5 - thickness, 0.5 + thickness, 1, 0.5 + thickness).move(x, y, z), aabbList);
+        }
     }
 
     @Override
@@ -50,7 +75,7 @@ public abstract class BlockLogicFenceThin extends BlockLogic
         return false;
     }
 
-    public abstract boolean canConnectTo(WorldSource world, int x, int y, int z);
+    public abstract boolean canConnectTo(@NotNull WorldSource world, int x, int y, int z, @NotNull Side side);
 
     public boolean shouldDrawColumn(WorldSource world, int x, int y, int z) {
         boolean drawColumn = shouldDrawColumn_do(world, x, y, z);
@@ -79,10 +104,10 @@ public abstract class BlockLogicFenceThin extends BlockLogic
 
     private boolean shouldDrawColumn_do(WorldSource world, int x, int y, int z)
     {
-        boolean connectNorth = canConnectTo(world, x + Direction.NORTH.getOffsetX(), y + Direction.NORTH.getOffsetY(), z + Direction.NORTH.getOffsetZ());
-        boolean connectSouth = canConnectTo(world, x + Direction.SOUTH.getOffsetX(), y + Direction.SOUTH.getOffsetY(), z + Direction.SOUTH.getOffsetZ());
-        boolean connectEast = canConnectTo(world, x + Direction.EAST.getOffsetX(), y + Direction.EAST.getOffsetY(), z + Direction.EAST.getOffsetZ());
-        boolean connectWest = canConnectTo(world, x + Direction.WEST.getOffsetX(), y + Direction.WEST.getOffsetY(), z + Direction.WEST.getOffsetZ());
+        boolean connectNorth = canConnectTo(world, x, y, z, Side.NORTH);
+        boolean connectSouth = canConnectTo(world, x, y, z, Side.SOUTH);
+        boolean connectEast = canConnectTo(world, x, y, z, Side.EAST);
+        boolean connectWest = canConnectTo(world, x, y, z, Side.WEST);
 
         boolean lineNorthSouth = connectNorth && connectSouth;
         boolean lineEastWest = connectEast && connectWest;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceWallPaper.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceWallPaper.java
index a8fa39226..2e0df70af 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceWallPaper.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceWallPaper.java
@@ -2,7 +2,9 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicFenceWallPaper extends BlockLogicFenceThin
 {
@@ -12,9 +14,9 @@ public class BlockLogicFenceWallPaper extends BlockLogicFenceThin
     }
 
     @Override
-    public boolean canConnectTo(WorldSource world, int x, int y, int z)
+    public boolean canConnectTo(@NotNull WorldSource world, int x, int y, int z, @NotNull Side side)
     {
-        int l = world.getBlockId(x, y, z);
-        return Blocks.hasTag(l, BlockTags.FENCES_CONNECT);
+        Block<?> b = world.getBlock(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ());
+        return Blocks.hasTag(b, BlockTags.FENCES_CONNECT) || (b != null && b.getAttachedSide(world, x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ()) == side.getOpposite());
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
index 4ffe4a40e..7e0e35403 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
@@ -99,10 +99,25 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
         boolean isPoweredFlagSet = (meta & MASK_POWERED) != 0;
         RailDirection railDirection = getRailDirection(world, x, y, z);
 
-        if(!isValidState(world, x, y, z)) {
+        if(!isSupported(world, x, y, z, Side.BOTTOM)) {
             dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
             world.setBlockWithNotify(x, y, z, 0);
             return;
+        } else if (!isRailValid(world, x, y, z)) {
+            switch (railDirection) {
+                case SLOPE_W:
+                case SLOPE_E: {
+                    railDirection = RailDirection.STRAIGHT_EW;
+                    world.setBlockMetadataWithNotify(x, y, z, railDirection.meta);
+                    break;
+                }
+                case SLOPE_N:
+                case SLOPE_S: {
+                    railDirection = RailDirection.STRAIGHT_NS;
+                    world.setBlockMetadataWithNotify(x, y, z, railDirection.meta);
+                    break;
+                }
+            }
         }
 
         Block<?> block = Blocks.getBlock(blockId);
@@ -137,20 +152,15 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
     }
     // Checks that the rail is placed on top of a block and doesn't slope into the air
 
-    private boolean isValidState(World world, int x, int y, int z){
-        if (!isSupported(world, x, y, z, Side.BOTTOM)) return false;
-
+    private boolean isRailValid(World world, int x, int y, int z){
         RailDirection railDirection = getRailDirection(world, x, y, z);
-        if(railDirection == RailDirection.SLOPE_E && !isSupported(world, x + 1, y + 1, z, Side.BOTTOM)) {
-            return false;
-        }
-        if(railDirection == RailDirection.SLOPE_W && !isSupported(world, x - 1, y + 1, z, Side.BOTTOM)) {
-            return false;
-        }
-        if(railDirection == RailDirection.SLOPE_N && !isSupported(world, x, y + 1, z - 1, Side.BOTTOM)) {
-            return false;
+        switch (railDirection) {
+            case SLOPE_E: return isSupported(world, x + 1, y + 1, z, Side.BOTTOM);
+            case SLOPE_W: return isSupported(world, x - 1, y + 1, z, Side.BOTTOM);
+            case SLOPE_N: return isSupported(world, x, y + 1, z - 1, Side.BOTTOM);
+            case SLOPE_S: return isSupported(world, x, y + 1, z + 1, Side.BOTTOM);
         }
-        return railDirection != RailDirection.SLOPE_S || isSupported(world, x, y + 1, z + 1, Side.BOTTOM);
+        return true;
     }
     // Turn logic what a regular rail is powered in an intersection
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
index aa9431773..b07628b83 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
@@ -10,6 +10,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
+import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
@@ -83,6 +84,22 @@ public class BlockLogicSign extends BlockLogic implements IPaintable
         return PartialSupport.INSTANCE;
     }
 
+    @Override
+    public @NotNull Side getAttachedSide(@NotNull WorldSource world, int x, int y, int z) {
+        switch (world.getBlockMetadata(x, y, z) & MASK_SIDE) {
+            case SIDE_NORTH:
+                return Side.SOUTH;
+            case SIDE_SOUTH:
+                return Side.NORTH;
+            case SIDE_WEST:
+                return Side.EAST;
+            case SIDE_EAST:
+                return Side.WEST;
+            default:
+                return Side.NONE;
+        }
+    }
+
     @Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
@@ -127,19 +144,26 @@ public class BlockLogicSign extends BlockLogic implements IPaintable
     @Override
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced) {
         TileEntitySign signEntity = (TileEntitySign)world.getTileEntity(x, y, z);
-        if (signEntity != null && player != null) {
-            if (player.getHeldItem() != null && player.getHeldItem().itemID == Items.DUST_GLOWSTONE.id && !signEntity.isGlowing()) {
-                signEntity.setGlowing(true);
-                if (player.getGamemode().consumeBlocks()) {
-                    player.getHeldItem().stackSize--;
+        if (signEntity != null) {
+            if (signEntity.isLocked()) return false;
+            if (player != null) {
+                ItemStack heldItem = player.getHeldItem();
+                if (heldItem != null && heldItem.itemID == Items.DUST_GLOWSTONE.id && !signEntity.isGlowing() && heldItem.consumeItem(player)) {
+                    signEntity.setGlowing(true);
+                    if (player.getGamemode().consumeBlocks()) {
+                        heldItem.stackSize--;
+                    }
+                    player.addStat(Achievements.LIGHT_SIGN, 1);
+                    return true;
+                } else if (heldItem != null && heldItem.itemID == Items.SLIMEBALL.id && heldItem.consumeItem(player)) {
+                    signEntity.setLocked(true);
+                    return true;
+                } else if (heldItem != null && (heldItem.itemID == Items.DYE.id || heldItem.itemID == Items.PAINTBRUSH.id)) {
+                    return false;
+                } else if (signEntity.isEditableBy(player)) {
+                    player.displaySignEditorScreen(signEntity);
+                    return true;
                 }
-                player.addStat(Achievements.LIGHT_SIGN, 1);
-                return true;
-            } else if (player.getHeldItem() != null && (player.getHeldItem().itemID == Items.DYE.id || player.getHeldItem().itemID == Items.PAINTBRUSH.id)) {
-                return false;
-            } else if (signEntity.isEditableBy(player)) {
-                player.displaySignEditorScreen(signEntity);
-                return true;
             }
         }
         return false;
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
index ad833a99a..88d956cb6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
@@ -21,6 +21,7 @@ public class TileEntitySign extends TileEntity
     private int selectedColor = 15;
     private @Nullable UUID owner;
     private boolean glowing = false;
+    private boolean locked = false;
 
     public TileEntitySign()
     {
@@ -37,6 +38,7 @@ public class TileEntitySign extends TileEntity
         compoundTag.putInt("Picture", selectedPicture);
         compoundTag.putInt("Color", selectedColor);
         compoundTag.putBoolean("Glowing", glowing);
+        compoundTag.putBoolean("Locked", locked);
         UUIDHelper.writeToTag(compoundTag, owner, "OwnerUUID");
     }
 
@@ -54,6 +56,7 @@ public class TileEntitySign extends TileEntity
         selectedPicture = compoundTag.getIntegerOrDefault("Picture", 0);
         selectedColor = compoundTag.getIntegerOrDefault("Color", 15);
         glowing = compoundTag.getBooleanOrDefault("Glowing", false);
+        locked = compoundTag.getBooleanOrDefault("Locked", false);
 
         UUID ownerUUID = UUIDHelper.readFromTag(compoundTag, "OwnerUUID");
         if (ownerUUID == null) {
@@ -70,7 +73,7 @@ public class TileEntitySign extends TileEntity
     
     public boolean isEditableBy(Player player)
     {
-        return player.uuid.equals(owner);
+        return player.uuid.equals(owner) && !locked;
     }
 
     public void setOwner(Player player){
@@ -112,6 +115,14 @@ public class TileEntitySign extends TileEntity
     public void setGlowing(boolean glowing) {
         this.glowing = glowing;
     }
+
+    public boolean isLocked() {
+        return locked;
+    }
+
+    public void setLocked(boolean locked) {
+        this.locked = locked;
+    }
     
     @Override
 	public Packet getDescriptionPacket()
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java b/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
index 247764890..ea20d7f3c 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
@@ -158,6 +158,7 @@ public final class EntityDispatcher
         stringIdToEntryMap.put(entry.stringID, entry);
         classToEntryMap.put(entry.entityClass, entry);
         numericIdToEntryMap.put(entry.numericID, entry);
+        numericIdToStringIdMap.put(entry.numericID, entry.stringID);
 
         return factory;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java b/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java
index 26aada370..49b91bea7 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java
@@ -40,8 +40,8 @@ public class EntityLightning extends Entity
         {
             world.playSoundEffect(null, SoundCategory.WEATHER_SOUNDS, x, y, z, "ambient.weather.thunder", 10000F, 0.8F + random.nextFloat() * 0.2F);
             world.playSoundEffect(null, SoundCategory.WEATHER_SOUNDS, x, y, z, "random.explode", 2.0F, 0.5F + random.nextFloat() * 0.2F);
-            for (int i = 0; i < world.loadedEntityList.size(); i++) {
-                Entity e = world.loadedEntityList.get(i);
+            for (int i = 0; i < world.entities.size(); i++) {
+                Entity e = world.entities.get(i);
                 if (e instanceof MobWolf) {
                     ((MobWolf) e).whine();
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java
index ab6066da0..daae51138 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java
@@ -9,7 +9,6 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.enums.LightLayer;
-import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.world.World;
@@ -55,7 +54,7 @@ public class MobZombiePig extends MobZombie
     {
         if (tickCount % 200 == 0 && target instanceof Player && ((Player) target).getStat(Achievements.MOST_WANTED) <= 0) {
             int agroNumber = 1;
-            for (Entity e : world.loadedEntityList) {
+            for (Entity e : world.entities) {
                 if (e instanceof MobZombiePig && ((MobZombiePig) e).target == this.target) {
                     agroNumber++;
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java b/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
index 13757c6e0..61dab17d4 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
@@ -9,6 +9,7 @@ import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
@@ -57,6 +58,8 @@ public class ItemDoor extends Item {
 			meta |= 0b100;
 			meta |= 0b1000;
 		}
+		meta |= (DyeColor.colorFromItemMeta(itemstack.getMetadata()).blockMeta) << 4 & 0xF0;
+
 		if(!doorBlockBottom.getLogic().canPlaceBlockAt(world, blockX, blockY, blockZ, meta)) {
 			return false;
 		}
@@ -107,6 +110,7 @@ public class ItemDoor extends Item {
 			meta |= 0b100;
 			meta |= 0b1000;
 		}
+		meta |= (DyeColor.colorFromItemMeta(itemStack.getMetadata()).blockMeta) << 4 & 0xF0;
 		if(!doorBlockBottom.getLogic().canPlaceBlockAt(world, blockX, blockY, blockZ, meta)) {
 			return;
 		}
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDoorPainted.java b/game/core/src/main/java/net/minecraft/core/item/ItemDoorPainted.java
index 6eed035e1..d3998c104 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDoorPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDoorPainted.java
@@ -2,67 +2,13 @@ package net.minecraft.core.item;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicDoor;
-import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.enums.EnumBlockSoundEffectType;
-import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
-import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.world.World;
-import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
 
 public class ItemDoorPainted extends ItemDoor {
     public ItemDoorPainted(String name, String namespaceId, int id, Block<? extends BlockLogicDoor> doorBottom, Block<? extends BlockLogicDoor> doorTopId) {
         super(name, namespaceId, id, doorBottom, doorTopId);
     }
     @Override
-    public boolean onUseItemOnBlock(@NotNull ItemStack itemstack, @Nullable Player player, @NotNull World world, int blockX, int blockY, int blockZ, @NotNull Side side, double xPlaced, double yPlaced) {
-        if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
-            blockX += side.getOffsetX();
-            blockY += side.getOffsetY();
-            blockZ += side.getOffsetZ();
-        }
-        if(!doorBlockBottom.canPlaceBlockAt(world, blockX, blockY, blockZ)) {
-            return false;
-        }
-
-        Direction dir = player.getHorizontalPlacementDirection(side).rotate(3);
-        int meta = dir.getHorizontalIndex();
-
-        int xOffset = -dir.getOffsetX();
-        int zOffset = -dir.getOffsetZ();
-
-        int isSolidBlockLeft = (world.isBlockNormalCube(blockX - xOffset, blockY, blockZ - zOffset) ? 1 : 0) + (world.isBlockNormalCube(blockX - xOffset, blockY + 1, blockZ - zOffset) ? 1 : 0);
-        int isSolidBlockRight = (world.isBlockNormalCube(blockX + xOffset, blockY, blockZ + zOffset) ? 1 : 0) + (world.isBlockNormalCube(blockX + xOffset, blockY + 1, blockZ + zOffset) ? 1 : 0);
-        boolean isDoorLeft = world.getBlockId(blockX - xOffset, blockY, blockZ - zOffset) == doorBlockBottom.id() || world.getBlockId(blockX - xOffset, blockY + 1, blockZ - zOffset) == doorBlockTop.id();
-        boolean isDoorRight = world.getBlockId(blockX + xOffset, blockY, blockZ + zOffset) == doorBlockBottom.id() || world.getBlockId(blockX + xOffset, blockY + 1, blockZ + zOffset) == doorBlockTop.id();
-        boolean isMirrored = false;
-
-        if(isDoorLeft && !isDoorRight) {
-            isMirrored = true;
-        } else if(isSolidBlockRight > isSolidBlockLeft) {
-            isMirrored = true;
-        }
-        if(isMirrored) {
-            meta = meta - 1 & 3;
-            meta += 4;
-            meta |= 0x8;
-        }
-        meta |= (15 - itemstack.getMetadata()) << 4 &0xF0;
-
-        world.noNeighborUpdate = true;
-        world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, doorBlockBottom.id(), meta);
-        world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, doorBlockTop.id(), meta);
-        world.noNeighborUpdate = false;
-        world.notifyBlocksOfNeighborChange(blockX, blockY, blockZ, doorBlockBottom.id());
-        world.notifyBlocksOfNeighborChange(blockX, blockY + 1, blockZ, doorBlockTop.id());
-        world.playBlockSoundEffect(player,blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, doorBlockBottom, EnumBlockSoundEffectType.PLACE);
-        doorBlockBottom.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, xPlaced, yPlaced);
-        doorBlockTop.onBlockPlacedByMob(world, blockX, blockY + 1, blockZ, side, player, xPlaced, yPlaced);
-        itemstack.consumeItem(player);
-        return true;
-    }
-    @Override
     public String getLanguageKey(ItemStack itemstack)
     {
         return super.getKey() + "." + DyeColor.colorFromItemMeta(itemstack.getMetadata()).colorID;
